# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/clock/apple,nco.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Apple SoCs' NCO block

maintainers:
  - Martin Povišer <povik+lin@cutebit.org>

description: |
  The NCO (Numerically Controlled Oscillator) block found on Apple SoCs
  such as the t8103 (M1) is a programmable clock generator performing
  fractional division of a high frequency input clock.

  It carries a number of independent channels and is typically used for
  generation of audio bitclocks.

properties:
  compatible:
    items:
      - enum:
          - apple,t6000-nco
          - apple,t8103-nco
      - const: apple,nco

  clocks:
    description:
      Specifies the reference clock from which the output clocks
      are derived through fractional division.
    maxItems: 1

  '#clock-cells':
    const: 1

  reg:
    maxItems: 1

required:
  - compatible
  - clocks
  - '#clock-cells'
  - reg

additionalProperties: false

examples:
  - |
    nco_clkref: clock-ref {
      compatible = "fixed-clock";
      #clock-cells = <0>;
      clock-frequency = <900000000>;
      clock-output-names = "nco-ref";
    };

    nco: clock-controller@23b044000 {
      compatible = "apple,t8103-nco", "apple,nco";
      reg = <0x3b044000 0x14000>;
      #clock-cells = <1>;
      clocks = <&nco_clkref>;
    };
